

% eine gerichter Graph

edge(a,b).
edge(b,c).
edge(b,f).
edge(d,a).
edge(d,e).
edge(e,f).
edge(e,g).
edge(f,g).


% reachabilty-Regeln aus der Aufgabenstellung

reachable(X,Y) :- edge(X,Y). 
reachable(X,Z) :- reachable(X,Y), edge(Y,Z).


% Loesung fuer azynklische Graphen

reach2(A,B) :- edge(A,B).
reach2(A,B) :- edge(A,C), reach2(C,B).



% allgemeine Loesung, funkioniert auch, wenn Zielknoten hinter 
% einem Kreis liegt

% edge(c,a).
% % edge(e,f).
% % edge(e,g).

reach(A,B) :- reach_l(A,B,[]).

reach_l(_,B,[B|_]).
reach_l(A,B,_) :- edge(A,B).

reach_l(A,B,T) :- edge(A,H), not(element(H,T)),reach_l(A,B,[H|T]).
reach_l(A,B,T) :- edge(K,C), not(element(C,T)), element(K,T), reach_l(A,B,[C|T]).


				    
% Hilfskonstrukt

element(X, [X|_]).
element(X, [_|R] ):- element(X, R).


